from lib.database.entities.user_trust import UserTrust
from datetime import datetime
from typing import Dict, List


class User:
    def __init__(self, use_case: str, name: str, context_trust: List[UserTrust] = []):
        self.use_case = use_case
        self.name = name
        self.context_trust = context_trust

    def to_serializable_dict(self, include_trust: bool = False):
        if include_trust:
            return {
                "use_case": self.use_case,
                "name": self.name,
                "context_trust": [t.to_serializable_dict() for t in self.context_trust]
            }
        else:
            return {
                "use_case": self.use_case,
                "name": self.name
            }

    @staticmethod
    def from_serializable_dict(data: Dict):
        if "use_case" not in data.keys() or "name" not in data.keys():
            raise ValueError("Missing fields for User!")

        return User(data["use_case"], data["name"])
