from lib.services.trust_service import TrustService
from typing import Dict
from flask import request, Response

from lib.database.repositories.trust_adapter_repository import TrustAdapterRepository
from lib.database.repositories.user_repository import UserRepository
from lib.database.repositories.user_trust_repository import UserTrustRepository
from lib.database.repositories.trust_trace_repository import TrustTraceRepository

trust_service: TrustService = TrustService(
    TrustAdapterRepository(),
    UserRepository(),
    UserTrustRepository(),
    TrustTraceRepository()
)

def add(use_case: str, table: str):
    data: Dict = request.json

    trust_service.updateSystem(use_case, table, data["properties"])